<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "functions" - Page-Template PHP-Functions             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.2b / January 2013 ==

*/

// create a regular expression with all available placeholders
$pageTagsPreg = '/[\[<]!--\s*(function)\s*:\s*([^;]*?)\s*(;\s*(.*?)\s*)?--[\]>]/si';

preg_match_all($pageTagsPreg, $template_datei, $pageMatches, PREG_SET_ORDER);
foreach ($pageMatches as $match) {
    $page_fullmatch = $match[0];
    $page_type      = strtolower(trim($match[1]));
    $page_name      = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[2]));
    $key            = $page_name.' ('.$page_type.')';
    $_params        = '';
    if (isset($match[4])) $_params = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[4]));

    // create an array with all parameters
    $prefix = '';
    $pageparameters = array();
    foreach (explode(';', $_params) as $value) {
        if (substr($value, -1)=='\\') {
            $prefix .= substr($value, 0, -1).';';
            continue;
        }
        $value = trim($prefix.$value);
        $prefix = '';
        if ($value=='') continue;

        // split 'a = b' or only 'a'
        preg_match('/\s*([^=]*)\s*(=(.*))?/', $value, $tmp);

        // no matches found?
        if (count($tmp)==0) continue;

        if (count($tmp)==2) { // only a flag
            $pageparameters[strtolower(trim($tmp[1]))] = true;
        }
        if (count($tmp)==4) { // a = b
            $pageparameters[strtolower(trim($tmp[1]))] = trim($tmp[3]);
        }
    }

    // create a replacement for the tag
    $pagereplacement = '<br />{{{{ ERROR: unable to find replacement for the following placeholder (unknown type?): }}}'.htmlspecialchars($page_fullmatch, ENT_COMPAT, 'ISO-8859-15')."<br />";

    switch ($page_type) {
    case 'function': // {{{
        $page_name = 'cpoPage' . ucfirst($page_name);
        if (!function_exists($page_name)) break;
        $pagereplacement = $page_name($_params);
        break; // }}}
    }

    $pagereplacer['/'.preg_quote($page_fullmatch, '/').'/'] = $pagereplacement;
}

// do the magic pattern replacing 
if (count($pagereplacer)>0)
    $template_datei = preg_replace(array_keys($pagereplacer), array_values($pagereplacer), $template_datei);

